diff -Naur src.pgsql/include/access/bitmap.h src.bitmap/include/access/bitmap.h
--- src.pgsql/include/access/bitmap.h	1969-12-31 16:00:00.000000000 -0800
+++ src.bitmap/include/access/bitmap.h	2006-09-17 00:09:34.000000000 -0700
@@ -0,0 +1,727 @@
+/*-------------------------------------------------------------------------
+ *
+ * bitmap.h
+ *	header file for on-disk bitmap index access method implementation.
+ *
+ * Copyright (c) 2006, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *	$PostgreSQL$
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#ifndef BITMAP_H
+#define BITMAP_H
+
+#include "access/htup.h"
+#include "access/itup.h"
+#include "access/relscan.h"
+#include "access/sdir.h"
+#include "access/xlogutils.h"
+#include "nodes/tidbitmap.h"
+#include "storage/lock.h"
+
+#define BM_READ		BUFFER_LOCK_SHARE
+#define BM_WRITE	BUFFER_LOCK_EXCLUSIVE
+#define BM_NOLOCK	(-1)
+
+/* the encoding schemes for a bitmap index */
+#define BM_EQUALITY		1
+
+/* the size in bits of a hybrid run-length(HRL) word */
+#define BM_HRL_WORD_SIZE		8
+/* the type for a HRL word */
+typedef uint8			BM_HRL_WORD;
+
+#define BM_HRL_WORD_LEFTMOST	(BM_HRL_WORD_SIZE-1)
+
+/*
+ * Metapage, always the first page (page 0) in the index.
+ *
+ * This page stores some meta-data information about this index.
+ */
+typedef struct BMMetaPageData 
+{
+	/* number of indexed tuples in this index */
+	uint64	bm_num_tuples;
+
+	/*
+	 * The relation ids for a heap and a btree on this heap. They are
+	 * used to speed up finding the bitmap vector for given attribute
+	 * value(s), see the comments for LOV pages below for more
+	 * information. We consider these as the metadata for LOV pages.
+	 */
+	Oid			bm_lov_heapId;		/* the relation id for the heap */
+	Oid			bm_lov_indexId;		/* the relation id for the index */
+
+	/* the block number for the last LOV pages. */
+	BlockNumber	bm_lov_lastpage;
+
+	/*
+	 * Indicates if the bitmap index needs to be re-built during
+	 * vacuuming.
+	 *
+	 * The vacuum command will check this value to determine if
+	 * this bitmap index needs to be re-built. This value is set to
+	 * true if there is an update to a bit that is in the middle
+	 * of its bitmap vector.
+	 */
+	bool		bm_need_rebuilt;
+
+} BMMetaPageData;
+
+typedef BMMetaPageData *BMMetaPage;
+
+#define BM_METAPAGE 	0
+
+/*
+ * The maximum number of heap tuples in one page that is considered
+ * in the bitmap index. We set this number to be a multiplication
+ * of BM_HRL_WORD_SIZE because we can then bits for heap
+ * tuples in different heap pages are stored in different words.
+ * This makes it easier during the search.
+ */
+#define BM_MAX_HTUP_PER_PAGE \
+	((((MaxHeapTuplesPerPage - 1) / BM_HRL_WORD_SIZE) + 1) * \
+	BM_HRL_WORD_SIZE)
+
+/*
+ * LOV (List Of Values) page -- pages to store a list of distinct
+ * values for attribute(s) to be indexed, some metadata related to
+ * their corresponding bitmap vectors, and the pointers to their
+ * bitmap vectors. For each distinct value, there is a BMLOVItemData
+ * associated with it. A LOV page maintains an array of BMLOVItemData
+ * instances, called lov items.
+ *
+ * To speed up finding the lov item for a given value, we
+ * create a heap to maintain all distinct values along with the
+ * block numbers and offset numbers for their lov items in LOV pages.
+ * That is, there are total "<number_of_attributes> + 2" attributes
+ * in this new heap. Along with this heap, we also create a new btree
+ * index on this heap using attribute(s) as btree keys. In this way,
+ * for any given value, we search this btree to find
+ * the block number and offset number for its corresponding lov item.
+ */
+
+#define		BM_LOV_STARTPAGE	1
+
+/*
+ * Items in a LOV page.
+ *
+ * Each item is corresponding to a distinct value for attribute(s)
+ * to be indexed. For multi-column indexes on (a_1,a_2,...,a_n), we say
+ * two values (l_1,l_2,...,l_n) and (k_1,k_2,...,k_n) for (a_1,a_2,...,a_n)
+ * are the same if and only if for all i, l_i=k_i.
+ * 
+ */
+typedef struct BMLOVItemData 
+{
+	/* the first page and last page of the bitmap vector. */
+	BlockNumber		bm_lov_head;
+	BlockNumber 	bm_lov_tail;
+
+	/* 
+	 * Additional information to be used to append new bits into
+	 * existing bitmap vector that this distinct value is associated with. 
+	 * The following two words do not store in the regular bitmap page,
+	 * defined below. 
+	 */
+
+	/* the last complete word in its bitmap vector. */
+	BM_HRL_WORD		bm_last_compword;
+
+	/*
+	 * the last word in its bitmap vector. This word is not
+	 * a complete word. If a new appending bit makes this word
+	 * to be complete, this word will merge with bm_last_compword.
+	 */
+	BM_HRL_WORD		bm_last_word;
+
+	/*
+	 * the tid location for the last bit stored in bm_last_compword.
+	 * A tid location represents the index position for a bit in a
+	 * bitmap vector, which is conceptualized as an array
+	 * of bits. This value -- the index position starts from 1, and
+     * is calculated through (block#)*BM_MAX_HTUP_PER_PAGE + (offset#),
+	 * where (block#) and (offset#) are from the heap tuple ctid.
+	 * This value is used while updating a bit in the middle of
+	 * its bitmap vector. When moving the last complete word to
+	 * the bitmap page, this value will also be written to that page.
+	 * Each bitmap page maintains a similar value -- the tid location
+	 * for the last bit stored in that page. This will help us
+	 * know the range of tid locations for bits in a bitmap page
+	 * without decompressing all bits.
+	 */
+	uint64			bm_last_tid_location;
+
+	/*
+	 * the tid location of the last bit whose value is 1 (a set bit).
+	 * Each bitmap vector will be visited only when there is a new
+	 * set bit to be appended/updated. In the appending case, a new
+	 * tid location is presented. With this value, we can calculate
+	 * how many bits are 0s between this new set bit and the previous
+	 * set bit.
+	 */
+	uint64			bm_last_setbit;
+
+	/*
+	 * Only two least-significant bits in this byte is used.
+	 *
+	 * If the first least-significant bit is 1, then it represents
+	 * that bm_last_word is a fill word. If the second least-significant
+	 * bit is 1, it represents that bm_last_compword is a fill word.
+	 */
+	uint8			bm_last_two_headerbits;
+	 
+} BMLOVItemData;
+
+typedef BMLOVItemData *BMLOVItem;
+
+#define	BMLOVITEM_SIZE(itup)	(IndexTupleSize(itup) + \
+	(sizeof(BMLOVItemData) - sizeof(IndexTupleData)))
+
+#define BM_MAX_LOVITEMS_PER_PAGE	\
+	((BLCKSZ-sizeof(PageHeaderData))/sizeof(BMLOVItemData))
+
+/*
+ * Bitmap page -- pages to store bits in a bitmap vector.
+ *
+ * Each bitmap page stores two parts of information: header words and
+ * content words. Each bit in the header words is corresponding to
+ * a word in the content words. If a bit in the header words is 1,
+ * then its corresponding content word is a compressed word. Otherwise,
+ * it is a literal word.
+ *
+ * If a content word is a fill word, it means that there is a sequence
+ * of 0 bits or 1 bits. The most significant bit in this content word
+ * represents the bits in this sequence are 0s or 1s. The rest of bits
+ * stores the value of "the number of bits / BM_HRL_WORD_SIZE".
+ */
+
+/*
+ * Opaque data for a bitmap page.
+ */
+typedef struct BMBitmapOpaqueData 
+{
+	uint32		bm_hrl_words_used;	/* the number of words used */
+	BlockNumber	bm_bitmap_next;		/* the next page for this bitmap */
+
+	/*
+	 * the tid location for the last bit in this page.
+     */
+	uint64		bm_last_tid_location;
+} BMBitmapOpaqueData;
+typedef BMBitmapOpaqueData *BMBitmapOpaque;
+
+#define BM_MAX_NUM_OF_HRL_WORDS_PER_PAGE \
+	((BLCKSZ - \
+	MAXALIGN(sizeof(PageHeaderData)) - \
+	MAXALIGN(sizeof(BMBitmapOpaqueData)))/sizeof(BM_HRL_WORD))
+
+#define BM_MAX_NUM_OF_HEADER_WORDS \
+	(BM_MAX_NUM_OF_HRL_WORDS_PER_PAGE/(BM_HRL_WORD_SIZE + 1))
+/*
+ * To make the last header word a complete word, we limit this number to
+ * the multiplication of the word size.
+ */
+#define BM_NUM_OF_HRL_WORDS_PER_PAGE \
+	(((BM_MAX_NUM_OF_HRL_WORDS_PER_PAGE - \
+	  BM_MAX_NUM_OF_HEADER_WORDS)/BM_HRL_WORD_SIZE) * BM_HRL_WORD_SIZE)
+
+/* debugging... */
+/*#define BM_MAX_NUM_OF_HEADER_WORDS 4
+#define BM_NUM_OF_HRL_WORDS_PER_PAGE 32*/
+
+typedef struct BMBitmapData
+{
+	BM_HRL_WORD bm_headerWords[BM_MAX_NUM_OF_HEADER_WORDS];
+	BM_HRL_WORD bm_contentWords[BM_NUM_OF_HRL_WORDS_PER_PAGE];
+} BMBitmapData;
+typedef BMBitmapData *BMBitmap;
+
+/* the maxinum tid locations in a BMTidLocsBuffer: # of distinct values *
+ * (# of tid locations for each distinct value + 1).
+ * We set the default to 100*10000. When the number of distinct values
+ * goes beyond 100, then we consider a BMTidLocsBuffer has 200*5000
+ * tid locations. If the number of distinct values goes beyond 200, then
+ * there are 300*3333. And so on.
+ */
+#define BM_NUM_DISTINCT_VALUES 100
+#define BM_MAX_TIDLOCS_PER_VALUE 10000
+#define BM_MAX_TIDLOCS	(BM_NUM_DISTINCT_VALUES*BM_MAX_TIDLOCS_PER_VALUE)
+
+/*
+ * BMTidLocsBuffer -- a buffer to store a list of tid locations of
+ * the last several set bits for each distinct value.
+ *
+ * This buffer is used during the bitmap index creation. This buffer is
+ * designed to avoid writing one bit at a time to a bitmap vector.
+ *
+ * Conceptually, without this buffer, when a new tuple is inserted
+ * into the bitmap index, the corresponding bitmap vector is retrieved,
+ * and a new set bit is inserted into this bitmap vector. When the next
+ * tuple comes in, it is very likely that another bitmap vector is
+ * requested, and a new page is visited. Thus, writing one set bit
+ * at a time may cause seeking among many different pages in the bitmap
+ * index.
+ *
+ * With this buffer, we are able to write out a list of set bits at once,
+ * which has the following two advantages:
+ *
+ * (1) The number of IOs is reduced. Writing a list of set bits together
+ *	   makes it possible to read the corresponding pages only once.
+ * (2) Pages belonging to a bitmap vector are close together. This can
+ *	   further increase the search performance.
+ */
+typedef struct BMTidLocsBuffer
+{
+	/*
+	 * the maximum number of distinct values that the relation attribute(s)
+	 * will have.
+	 */
+	uint32	bm_max_values;
+
+	/* 
+	 * This array will be divided into "bm_max_values" parts, each of which
+	 * is corresponding to one distinct value. In the other words, each
+	 * distinct value has at most BM_MAX_TIDLOCS/bm_max_values tid locations
+	 * stored in this array.
+	 */
+	uint64	bm_tidLocs[BM_MAX_TIDLOCS];
+} BMTidLocsBuffer;
+
+#define BM_MAX_TIDLOCS_BUFFER_SIZE \
+	sizeof(BMTidLocsBuffer)
+
+/*
+ * The number of tid locations to be found at once during query processing.
+ */
+#define BM_BATCH_TIDS  16*1024
+
+/*
+ * the maximum number of words to be retrieved during BitmapIndexScan.
+ */
+#define BM_MAX_WORDS BM_NUM_OF_HRL_WORDS_PER_PAGE*4
+
+/* Some macros for manipulating a bitmap word. */
+#define LITERAL_ALL_ZERO	0
+#define LITERAL_ALL_ONE		((BM_HRL_WORD)(~((BM_HRL_WORD)0)))
+
+#define BM_MAKE_FILL_WORD(bit, length) \
+	((((BM_HRL_WORD)bit) << (BM_HRL_WORD_SIZE-1)) | (length))
+
+#define FILL_LENGTH(w)		(((BM_HRL_WORD)(((BM_HRL_WORD)(w))<<1))>>1)
+
+#define MAX_FILL_LENGTH		((((BM_HRL_WORD)1)<<(BM_HRL_WORD_SIZE-1))-1)
+
+/* get the left most bit of the word */
+#define GET_FILL_BIT(w)		(((BM_HRL_WORD)(w))>>BM_HRL_WORD_LEFTMOST)
+
+/*
+ * Given a word number, determine the bit position it that holds in its
+ * header word.
+ */
+#define WORDNO_GET_HEADER_BIT(cw_no) \
+	((BM_HRL_WORD)1 << (BM_HRL_WORD_SIZE - 1 - ((cw_no) % BM_HRL_WORD_SIZE)))
+
+/*
+ * To see if the content word at cw_no is a compressed word or not we must look
+ * look in the header words h_words. Each bit in the header words corresponds
+ * to a word amongst the content words. If the bit is 1, the word is compressed
+ * (i.e., it is a fill word) otherwise it is uncompressed.
+ *
+ * See src/backend/access/bitmap/README for more details
+ */
+
+#define IS_FILL_WORD(h_words, cw_no) \
+	(((h_words)[(cw_no)/BM_HRL_WORD_SIZE]) & WORDNO_GET_HEADER_BIT(cw_no))
+
+#define BM_NUM_LOV_BLOCKS 	100
+
+/*
+ * Calculate the number of header words we need given the number of
+ * content words
+ */
+#define BM_CALC_H_WORDS(c_words) \
+	(c_words/BM_HRL_WORD_SIZE +  \
+        ((c_words % BM_HRL_WORD_SIZE == 0) ? 0 : 1))
+
+/*
+ * Convert an ItemPointer to and from an integer representation
+ */
+
+#define BM_IPTR_TO_INT(iptr) \
+	((uint64)ItemPointerGetBlockNumber(iptr) * BM_MAX_HTUP_PER_PAGE + \
+		(uint64)ItemPointerGetOffsetNumber(iptr))
+
+#define BM_INT_GET_BLOCKNO(i) \
+	((i - 1)/BM_MAX_HTUP_PER_PAGE)
+
+#define BM_INT_GET_OFFSET(i) \
+	(((i - 1) % BM_MAX_HTUP_PER_PAGE) + 1)
+
+/*
+ * the state for build 
+ */
+typedef struct BMBuildState
+{
+	Buffer			bm_metabuf;
+
+	TupleDesc		bm_tupDesc;
+	Relation		bm_lov_heap;
+	Relation		bm_lov_index;
+	ScanKey			bm_lov_scanKeys;
+	IndexScanDesc	bm_lov_scanDesc;
+
+	/*
+	 * the buffer to store last several tid locations for each distinct
+	 * value.
+	 */
+	BMTidLocsBuffer*	bm_tidLocsBuffer;
+
+	/* 
+	 * arrays to store the block numbers for all LOV pages. 
+	 *
+	 * This is used to calcuate the starting index position for each
+	 * distinct value in BMTidLocsBuffer.bm_tidLocs. Assume that
+	 * the lov item for a distinct value is stored in <n>th LOV pages,
+	 * and the offset number of <f>, then the starting index position
+	 * for this distinct value in BMTidLocsBuffer.bm_tidLocs is
+	 * <n>*BM_MAX_LOVITEMS_PER_PAGE + (<f>-1).
+	 *
+	 * This array should be sorted.
+	 */
+	uint16			bm_max_num_lov_blocks;
+	uint16			bm_num_lov_blocks;
+	BlockNumber*	bm_lov_blocks;
+	double 			ituples;	/* the number of index tuples */
+	bool			use_wal;	/* whether or not we write WAL records */
+} BMBuildState ;
+
+/*
+ * Define an iteration result while scanning an BMBatchWords.
+ *
+ * This result includes the last scan position in an BMBatchWords,
+ * and all tids that are generated from previous scan.
+ */
+typedef struct BMIterateResult
+{
+	uint64	nextTid; /* the first tid for the next iteration */
+	/* the position in a bitmap word after the last iteration */
+	uint32	lastScanPos; 
+    /* the position of the bitmap word in an BMBatchWords after
+       the last iteration */
+	uint32	lastScanWordNo;
+    /* the tids generated from the previous iteration */
+	uint64	nextTids[BM_BATCH_TIDS];
+    /* number of tids generated from the previous iteration */
+	uint32	numOfTids;
+    /* the next position in 'nextTids' to be read. */
+	uint32	nextTidLoc;
+} BMIterateResult;
+
+/*
+ * Stores a batch of consecutive bitmap words from a bitmap vector.
+ *
+ * These bitmap words come from a bitmap vector stored in this bitmap
+ * index, or a bitmap vector that is generated by ANDing/ORing several
+ * bitmap vectors.
+ *
+ * This struct also contains information to compute the tid locations
+ * for the set bits in these bitmap words.
+ */
+typedef struct BMBatchWords
+{
+	uint32	maxNumOfWords;		/* maximum number of words in this list */
+
+	/* The following two variables are for performing AND/OR operations */
+
+	/* number of words that have been read in this list */
+	uint32	numOfWordsRead;
+	/* the position of the next word to be read */
+	uint32	nextReadNo;
+
+	/* the starting tid number of this list of bitmap words */
+	uint64	firstTid;
+	/* the starting position of meaningful bitmap words in the list */
+	uint32	startNo;
+	uint32	numOfWords;			/* the number of bitmap words in this list */
+	BM_HRL_WORD *bitmapHeaderWords; /* the header words */
+	BM_HRL_WORD *bitmapContentWords;	/* the list of bitmap words */	
+} BMBatchWords;
+
+/*
+ * Scan opaque data for one bitmap vector.
+ *
+ * This structure stores a batch of consecutive bitmap words for a
+ * bitmap vector that have been read from the disk, and remembers
+ * the next reading position for the next batch of consecutive
+ * bitmap words.
+ */
+typedef struct BMBitmapScanPositionData
+{
+	Buffer			bm_lovBuffer;/* the buffer that contains the LOV item. */
+	OffsetNumber	bm_lovOffset;	/* the offset of the LOV item */
+	BlockNumber		bm_nextBlockNo; /* the next bitmap page block */
+
+	/* indicate if the last two words in the bitmap has been read. 
+	 * These two words are stored inside a BMLovItem. If this value
+	 * is true, it means this bitmap vector has no more words.
+	 */
+	bool			bm_readLastWords;
+
+	/* the words in one bitmap vector that is necessary to obtain
+	   the final bitmap vector for the query. */
+	BMBatchWords   *bm_batchWords;
+
+} BMBitmapScanPositionData;
+typedef BMBitmapScanPositionData *BMBitmapScanPosition;
+
+/*
+ * Defines the current position of a scan.
+ *
+ * For each scan, all related bitmap vectors are read from the bitmap
+ * index, and ORed together into a final bitmap vector. The words
+ * in each bitmap vector are read in batches. This structure stores
+ * the following:
+ * (1) words for a final bitmap vector after ORing words from
+ *     related bitmap vectors. 
+ * (2) tid locations that satisfy the query.
+ * (3) One BMBitmapScanPositionData for each related bitmap vector.
+ */
+typedef struct BMScanPositionData
+{
+	/* indicate if this scan is over. */
+	bool			bm_done;
+
+	/* the number of related bitmap vectors */
+	int				bm_numBitmapVectors;
+
+	/*
+	 * the start position of bitmap vectors appearing at the end of
+	 * this structure that have not been processed.
+	 */
+	int				bm_startBitmapVectorNo;
+
+	/* the words in the final bitmap vector that satisfies the query. */
+	BMBatchWords   *bm_batchWords;
+
+	/*
+	 * the BMIterateResult instance that contains the final 
+	 * tid locations for tuples that satisfy the query.
+	 */
+	BMIterateResult bm_result;
+
+	/*
+	 * the StreamBitmap instance.
+	 */
+	StreamBitmap	bm_streamBitmap;
+
+	/*
+	 * one or more BMBitmapScanPositionData, depending on
+	 * the query predicates.
+	 */
+	BMBitmapScanPosition	bm_bitmapScanPos;
+
+	/* is this scan position being used for a bitmap stream? */
+	bool	isstream;
+} BMScanPositionData;
+
+typedef BMScanPositionData *BMScanPosition;
+
+typedef struct BMScanOpaqueData
+{
+	BMScanPosition		bm_currPos;
+	BMScanPosition		bm_markPos;
+} BMScanOpaqueData;
+
+typedef BMScanOpaqueData *BMScanOpaque;
+
+/*
+ * XLOG records for bitmap index operations
+ *
+ * Some information in high 4 bits of log record xl_info field.
+ */
+#define XLOG_BITMAP_INSERT_NEWMETA	0x00 /* add a new metapage */
+#define XLOG_BITMAP_INSERT_NEWLOV	0x10 /* add a new LOV page */
+#define XLOG_BITMAP_INSERT_LOVITEM	0x20 /* add a new entry into a LOV page */
+#define XLOG_BITMAP_INSERT_META		0x30 /* update the metapage */
+#define XLOG_BITMAP_INSERT_NEWBITMAP	0x40 /* add a new bitmap page */
+#define XLOG_BITMAP_INSERT_BITMAP	0x50 /* add a new set bit */
+#define XLOG_BITMAP_INSERT_BITMAP_LASTWORDS	0x60 /* update the last 2 words
+													in a bitmap */
+
+/* The information about inserting a new lovitem into the LOV list. */
+typedef struct xl_bm_lovitem
+{
+	RelFileNode 	bm_node;
+	BlockNumber		bm_lov_blkno;
+	bool			bm_isNewItem;
+	OffsetNumber	bm_lov_offset;
+	BMLOVItemData	bm_lovItem;
+} xl_bm_lovitem;
+
+/* The information about adding a new page */
+typedef struct xl_bm_newpage{
+	RelFileNode 	bm_node;
+	BlockNumber		bm_new_blkno;
+} xl_bm_newpage;
+
+/*
+ * The information about changes on a bitmap page. 
+ * If bm_isOpaque is true, then bm_next_blkno is set.
+ */
+typedef struct xl_bm_bitmappage{
+	RelFileNode 	bm_node;
+	BlockNumber		bm_bitmap_blkno;
+
+	bool			bm_isOpaque;
+	BlockNumber		bm_next_blkno;
+
+	uint32			bm_last_tid_location;
+	uint32			bm_hrl_words_used;
+	uint32			bm_num_words;
+	/* for simplicity, we log the header words each time */
+	BM_HRL_WORD 	bm_headerWords[BM_MAX_NUM_OF_HEADER_WORDS];
+	/* followed by the "bm_num_words" content words. */
+} xl_bm_bitmappage;
+
+/* The information about changes to the last 2 words in a bitmap vector */
+typedef struct xl_bm_bitmap_lastwords
+{
+	RelFileNode 	bm_node;
+	BM_HRL_WORD		bm_last_compword;
+	BM_HRL_WORD		bm_last_word;
+	uint8			bm_last_two_headerbits;
+
+	BlockNumber		bm_lov_blkno;
+	OffsetNumber	bm_lov_offset;
+} xl_bm_bitmap_lastwords;
+
+/* The information about the changes in the metapage. */
+typedef struct xl_bm_metapage
+{
+	RelFileNode bm_node;
+	uint64		bm_num_tuples;
+	Oid			bm_lov_heapId;		/* the relation id for the heap */
+	Oid			bm_lov_indexId;		/* the relation id for the index */
+	/* the block number for the last LOV pages. */
+	BlockNumber	bm_lov_lastpage;
+	/* indicate if this bitmap index needs to be re-built while vacuuming. */
+	bool		bm_need_rebuilt;
+} xl_bm_metapage;
+
+/* public routines */
+extern Datum bmbuild(PG_FUNCTION_ARGS);
+extern Datum bminsert(PG_FUNCTION_ARGS);
+extern Datum bmbeginscan(PG_FUNCTION_ARGS);
+extern Datum bmgettuple(PG_FUNCTION_ARGS);
+extern Datum bmgetbitmap(PG_FUNCTION_ARGS);
+extern Datum bmrescan(PG_FUNCTION_ARGS);
+extern Datum bmendscan(PG_FUNCTION_ARGS);
+extern Datum bmmarkpos(PG_FUNCTION_ARGS);
+extern Datum bmrestrpos(PG_FUNCTION_ARGS);
+extern Datum bmbulkdelete(PG_FUNCTION_ARGS);
+extern Datum bmvacuumcleanup(PG_FUNCTION_ARGS);
+extern Datum bmoptions(PG_FUNCTION_ARGS);
+
+/* bitmappages.c */
+extern Buffer _bitmap_getbuf(Relation rel, BlockNumber blkno, int access);
+extern void _bitmap_wrtbuf(Buffer buf);
+extern void _bitmap_relbuf(Buffer buf);
+extern void _bitmap_wrtnorelbuf(Buffer buf);
+extern void _bitmap_init_lovpage(Relation rel, Buffer buf);
+extern void _bitmap_init_bitmappage(Relation rel, Buffer buf);
+extern void _bitmap_init_buildstate(Relation index, BMBuildState* bmstate);
+extern void _bitmap_cleanup_buildstate(Relation index, BMBuildState* bmstate);
+extern void _bitmap_init(Relation rel, bool use_wal);
+
+/* bitmapinsert.c */
+extern void _bitmap_buildinsert(Relation rel, ItemPointerData ht_ctid, 
+								Datum *attdata, bool *nulls,
+							 	BMBuildState *state);
+extern void _bitmap_doinsert(Relation rel, ItemPointerData ht_ctid, 
+							 Datum *attdata, bool *nulls);
+extern void _bitmap_write_alltids(Relation rel, Buffer metabuf, 
+						  		  BMTidLocsBuffer *tidLocsBuffer,
+						  		  uint64 tidLocsPerValue,
+						  		  BlockNumber *lovBlocks, bool use_wal);
+
+/* bitmaputil.c */
+extern BMLOVItem _bitmap_formitem(uint64 currTidNumber);
+extern void _bitmap_init_batchwords(BMBatchWords* words,
+									uint32	maxNumOfWords,
+									MemoryContext mcxt);
+extern void _bitmap_reset_batchwords(BMBatchWords* words);
+extern void _bitmap_cleanup_batchwords(BMBatchWords* words);
+extern uint64 _bitmap_findnexttid(BMBatchWords *words,
+								  BMIterateResult *result);
+extern void _bitmap_findprevtid(BMIterateResult *result);
+extern void _bitmap_findnexttids(BMBatchWords *words,
+								 BMIterateResult *result, uint32 maxTids);
+extern bool _bitmap_getbitmapinpage(BMBatchWords* words,
+									BMIterateResult* result,
+									BlockNumber nextBlockNo,
+									PagetableEntry* entry);
+extern void _bitmap_intersect(BMBatchWords **batches, uint32 numBatches,
+						   BMBatchWords *result);
+extern void _bitmap_union(BMBatchWords **batches, uint32 numBatches,
+					   BMBatchWords *result);
+extern void _bitmap_begin_iterate(BMBatchWords *words,
+								  BMIterateResult* result);
+extern void _bitmap_log_newpage
+	(Relation rel, uint8 info, Buffer buf);
+extern void _bitmap_log_metapage(Relation rel, Page page);
+extern void _bitmap_log_bitmappage
+	(Relation rel, Buffer bitmapBuffer, bool isOpaque, uint32 numWords);
+extern void _bitmap_log_bitmap_lastwords
+	(Relation rel, Buffer lovBuffer,
+	 OffsetNumber lovOffset, BMLOVItem lovItem);
+extern void _bitmap_log_lovitem
+	(Relation rel, Buffer lovBuffer, bool isNewItem,
+	 OffsetNumber offset, BMLOVItem lovItem);
+
+/* bitmapsearch.c */
+extern void _bitmap_searchinit(IndexScanDesc scan, ScanDirection dir);
+extern bool _bitmap_first(IndexScanDesc scan, ScanDirection dir);
+extern bool _bitmap_next(IndexScanDesc scan, ScanDirection dir);
+extern bool _bitmap_firstbatchwords(IndexScanDesc scan, ScanDirection dir);
+extern bool _bitmap_nextbatchwords(IndexScanDesc scan, ScanDirection dir);
+extern void _bitmap_findbitmaps(IndexScanDesc scan, ScanDirection dir);
+
+
+
+/* bitmapattutil.c */
+extern void _bitmap_create_lov_heapandindex
+	(Relation rel, Oid *heapId, Oid *indexId);
+extern void _bitmap_open_lov_heapandindex
+	(Relation rel, BMMetaPage metapage,
+	 Relation *lovHeapP, Relation *lovIndexP,
+	 LOCKMODE lockMode);
+extern void _bitmap_insert_lov
+	(Relation lovHeap, Relation lovIndex, Datum* datum, bool* nulls);
+extern void _bitmap_close_lov_heapandindex
+	(Relation lovHeap, Relation lovIndex, LOCKMODE lockMode);
+extern bool _bitmap_findvalue
+	(Relation lovHeap, Relation lovIndex,
+	 ScanKey scanKey, IndexScanDesc scanDesc,
+	 BlockNumber *lovBlock, bool *blockNull,
+	 OffsetNumber *lovOffset, bool *offsetNull);
+extern void _bitmap_insert_lov_block_number(BlockNumber lovBlock,
+								BlockNumber** lovBlocks,
+								uint16*		numLovBlocks,
+								uint16*		maxNumLovBlocks);
+extern uint16
+_bitmap_find_lov_index(BlockNumber lovBlock, BlockNumber* lovBlocks,
+						uint16 numLovBlocks);
+
+
+/*
+ * prototypes for functions in bitmapxlog.c
+ */
+extern void bitmap_redo(XLogRecPtr lsn, XLogRecord *record);
+extern void bitmap_undo(XLogRecPtr lsn, XLogRecord *record);
+extern void bitmap_desc(StringInfo buf, uint8 xl_info, char *rec);
+
+#endif
diff -Naur src.pgsql/include/access/genam.h src.bitmap/include/access/genam.h
--- src.pgsql/include/access/genam.h	2006-09-16 17:51:34.000000000 -0700
+++ src.bitmap/include/access/genam.h	2006-09-17 00:09:34.000000000 -0700
@@ -17,6 +17,7 @@
 #include "access/relscan.h"
 #include "access/sdir.h"
 #include "nodes/primnodes.h"
+#include "nodes/tidbitmap.h"
 #include "storage/lock.h"
 
 /*
@@ -98,7 +99,7 @@
 				Relation indexRelation,
 				Snapshot snapshot,
 				int nkeys, ScanKey key);
-extern IndexScanDesc index_beginscan_multi(Relation indexRelation,
+extern IndexScanDesc index_beginscan_bitmap(Relation indexRelation,
 					  Snapshot snapshot,
 					  int nkeys, ScanKey key);
 extern void index_rescan(IndexScanDesc scan, ScanKey key);
@@ -108,9 +109,9 @@
 extern HeapTuple index_getnext(IndexScanDesc scan, ScanDirection direction);
 extern bool index_getnext_indexitem(IndexScanDesc scan,
 						ScanDirection direction);
-extern bool index_getmulti(IndexScanDesc scan,
-			   ItemPointer tids, int32 max_tids,
-			   int32 *returned_tids);
+extern Node* index_getbitmap(IndexScanDesc	scan,
+							 HashBitmap*		hashBitmap,
+							 BlockNumber		nextBlockNo);
 
 extern IndexBulkDeleteResult *index_bulk_delete(IndexVacuumInfo *info,
 				  IndexBulkDeleteResult *stats,
diff -Naur src.pgsql/include/access/gin.h src.bitmap/include/access/gin.h
--- src.pgsql/include/access/gin.h	2006-09-16 17:51:34.000000000 -0700
+++ src.bitmap/include/access/gin.h	2006-09-17 00:09:34.000000000 -0700
@@ -398,7 +398,7 @@
 #define ItemPointerSetMin(p)	ItemPointerSet( (p), (BlockNumber)0, (OffsetNumber)0) 
 #define ItemPointerIsMin(p)	( ItemPointerGetBlockNumber(p) == (BlockNumber)0 && ItemPointerGetOffsetNumber(p) == (OffsetNumber)0 ) 
 
-extern Datum gingetmulti(PG_FUNCTION_ARGS);
+extern Datum gingetbitmap(PG_FUNCTION_ARGS);
 extern Datum gingettuple(PG_FUNCTION_ARGS);
 
 /* ginvacuum.c */
diff -Naur src.pgsql/include/access/gist_private.h src.bitmap/include/access/gist_private.h
--- src.pgsql/include/access/gist_private.h	2006-09-16 17:51:34.000000000 -0700
+++ src.bitmap/include/access/gist_private.h	2006-09-17 00:09:34.000000000 -0700
@@ -266,7 +266,7 @@
 
 /* gistget.c */
 extern Datum gistgettuple(PG_FUNCTION_ARGS);
-extern Datum gistgetmulti(PG_FUNCTION_ARGS);
+extern Datum gistgetbitmap(PG_FUNCTION_ARGS);
 
 /* gistutil.c */
 
diff -Naur src.pgsql/include/access/hash.h src.bitmap/include/access/hash.h
--- src.pgsql/include/access/hash.h	2006-09-16 17:51:34.000000000 -0700
+++ src.bitmap/include/access/hash.h	2006-09-17 00:09:34.000000000 -0700
@@ -231,7 +231,7 @@
 extern Datum hashinsert(PG_FUNCTION_ARGS);
 extern Datum hashbeginscan(PG_FUNCTION_ARGS);
 extern Datum hashgettuple(PG_FUNCTION_ARGS);
-extern Datum hashgetmulti(PG_FUNCTION_ARGS);
+extern Datum hashgetbitmap(PG_FUNCTION_ARGS);
 extern Datum hashrescan(PG_FUNCTION_ARGS);
 extern Datum hashendscan(PG_FUNCTION_ARGS);
 extern Datum hashmarkpos(PG_FUNCTION_ARGS);
diff -Naur src.pgsql/include/access/nbtree.h src.bitmap/include/access/nbtree.h
--- src.pgsql/include/access/nbtree.h	2006-09-16 17:51:34.000000000 -0700
+++ src.bitmap/include/access/nbtree.h	2006-09-17 00:09:34.000000000 -0700
@@ -468,7 +468,7 @@
 extern Datum btinsert(PG_FUNCTION_ARGS);
 extern Datum btbeginscan(PG_FUNCTION_ARGS);
 extern Datum btgettuple(PG_FUNCTION_ARGS);
-extern Datum btgetmulti(PG_FUNCTION_ARGS);
+extern Datum btgetbitmap(PG_FUNCTION_ARGS);
 extern Datum btrescan(PG_FUNCTION_ARGS);
 extern Datum btendscan(PG_FUNCTION_ARGS);
 extern Datum btmarkpos(PG_FUNCTION_ARGS);
diff -Naur src.pgsql/include/access/relscan.h src.bitmap/include/access/relscan.h
--- src.pgsql/include/access/relscan.h	2006-09-16 17:51:34.000000000 -0700
+++ src.bitmap/include/access/relscan.h	2006-09-17 00:09:34.000000000 -0700
@@ -50,7 +50,7 @@
 
 /*
  * We use the same IndexScanDescData structure for both amgettuple-based
- * and amgetmulti-based index scans.  Some fields are only relevant in
+ * and amgetbitmap-based index scans.  Some fields are only relevant in
  * amgettuple-based scans.
  */
 typedef struct IndexScanDescData
@@ -61,7 +61,7 @@
 	Snapshot	xs_snapshot;	/* snapshot to see */
 	int			numberOfKeys;	/* number of scan keys */
 	ScanKey		keyData;		/* array of scan key descriptors */
-	bool		is_multiscan;	/* TRUE = using amgetmulti */
+	bool		is_bitmapscan;	/* TRUE = using amgetbitmap */
 
 	/* signaling to index AM about killing index tuples */
 	bool		kill_prior_tuple;		/* last-returned tuple is dead */
diff -Naur src.pgsql/include/access/rmgr.h src.bitmap/include/access/rmgr.h
--- src.pgsql/include/access/rmgr.h	2006-09-16 17:51:34.000000000 -0700
+++ src.bitmap/include/access/rmgr.h	2006-09-17 00:09:34.000000000 -0700
@@ -26,6 +26,7 @@
 #define RM_GIN_ID				13
 #define RM_GIST_ID				14
 #define RM_SEQ_ID				15
-#define RM_MAX_ID				RM_SEQ_ID
+#define RM_BITMAP_ID			16
+#define RM_MAX_ID				RM_BITMAP_ID
 
 #endif   /* RMGR_H */
